C  Error function
      DOUBLE PRECISION FUNCTION MAP_UTIL_DAERF(Y)
      IMPLICIT NONE            
      INTEGER            ISW,I
      DOUBLE PRECISION   P(5),Q(3),P1(8),Q1(7),P2(5),Q2(4)
      DOUBLE PRECISION  Y,XMIN,XLARGE,SSQPI,X,RES,XNUM,XDEN,XSQ,XI
C                                  COEFFICIENTS FOR 0.0 .LE. Y .LT.
C                                  .477
      DATA               P(1)/-.44422647396874/,
     1                   P(2)/10.731707253648/,
     2                   P(3)/15.915606197771/,
     3                   P(4)/374.81624081284/,
     4                   P(5)/2.5612422994823D-02/
      DATA               Q(1)/17.903143558843/,
     1                   Q(2)/124.82892031581/,
     2                   Q(3)/332.17224470532/
C                                  COEFFICIENTS FOR .477 .LE. Y
C                                  .LE. 4.0
      DATA               P1(1)/7.2117582508831/,
     1                   P1(2)/43.162227222057/,
     2                   P1(3)/152.98928504694/,
     3                   P1(4)/339.32081673434/,
     4                   P1(5)/451.91895371187/,
     5                   P1(6)/300.45926102016/,
     6                   P1(7)/-1.3686485738272D-07/,
     7                   P1(8)/.56419551747897/
      DATA               Q1(1)/77.000152935229/,
     1                   Q1(2)/277.58544474399/,
     2                   Q1(3)/638.98026446563/,
     3                   Q1(4)/931.35409485061/,
     4                   Q1(5)/790.95092532790/,
     5                   Q1(6)/300.45926095698/,
     6                   Q1(7)/12.782727319629/
C                                  COEFFICIENTS FOR 4.0 .LT. Y
      DATA               P2(1)/-.22695659353969/,
     1                   P2(2)/-4.9473091062325D-02/,
     2                   P2(3)/-2.9961070770354D-03/,
     3                   P2(4)/-2.2319245973418D-02/,
     4                   P2(5)/-2.7866130860965D-01/
      DATA               Q2(1)/1.0516751070679/,
     1                   Q2(2)/.19130892610783/,
     2                   Q2(3)/1.0620923052847D-02/,
     3                   Q2(4)/1.9873320181714/
C                                  CONSTANTS
      DATA               XMIN/1.0D-8/,XLARGE/5.6875D0/
      DATA               SSQPI/.56418958354776/
C                                  FIRST EXECUTABLE STATEMENT
      X = Y
      ISW = 1
      IF (X.GE.0.0D0) GO TO 5
      ISW = -1
      X = -X
    5 IF (X.LT..477D0) GO TO 10
      IF (X.LE.4.0D0) GO TO 25
      IF (X.LT.XLARGE) GO TO 35
      RES = 1.D0
      GO TO 50
C                                  ABS(Y) .LT. .477, EVALUATE
C                                  APPROXIMATION FOR ERF
   10 IF (X.LT.XMIN) GO TO 20
      XSQ = X*X
      XNUM = P(5)
      DO 15 I=1,4
         XNUM = XNUM*XSQ+P(I)
   15 CONTINUE
      XDEN = ((Q(1)+XSQ)*XSQ+Q(2))*XSQ+Q(3)
      RES = X*XNUM/XDEN
      GO TO 50
   20 RES = X*P(4)/Q(3)
      GO TO 50
C                                  .477 .LE. ABS(Y) .LE. 4.0
C                                  EVALUATE APPROXIMATION FOR ERF
   25 XSQ = X*X
      XNUM = P1(7)*X+P1(8)
      XDEN = X+Q1(7)
      DO 30 I=1,6
         XNUM = XNUM*X+P1(I)
         XDEN = XDEN*X+Q1(I)
   30 CONTINUE
      RES = XNUM/XDEN
      GO TO 45
C                                  4.0 .LT. ABS(Y), EVALUATE
C                                  APPROXIMATION FOR ERF
   35 XSQ = X*X
      XI = 1.0D0/XSQ
      XNUM = P2(4)*XI+P2(5)
      XDEN = XI+Q2(4)
      DO 40 I=1,3
         XNUM = XNUM*XI+P2(I)
         XDEN = XDEN*XI+Q2(I)
   40 CONTINUE
      RES = (SSQPI+XI*XNUM/XDEN)/X
   45 RES = RES*DEXP(-XSQ)
      RES = 1.0D0-RES
   50 IF (ISW.EQ.-1) RES = -RES
      MAP_UTIL_DAERF = RES
      RETURN
      END
